"""Run ANUGA dependencies

Usage

python run_anuga_dependencies <anuga script>

E.g:

python run_anuga_dependencies.py /home/work/sandpit/anuga/anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py

"""

import os, sys
if __name__ == '__main__':

    if len(sys.argv) != 2:
        print 'Usage:\n    python %s <anuga script>' % sys.argv[0]
    else:        
        script = sys.argv[1]
        
        basename, ext = os.path.splitext(script)
        msg = 'Script "%s" must be a Python file' % script
        assert ext == '.py', msg

        depgraph = os.path.split(basename)[-1] + '_depgraph.png'
        
        s = 'python py2depgraph.py %s | python anuga_depgraph2dot.py | dot -T png -o %s' % (script, depgraph)
        print s
        os.system(s)
